/* DisplaysView.c generated by valac 0.56.17, the Vala compiler
 * generated from DisplaysView.vala, do not modify */

/*-
 * Copyright (c) 2014-2018 elementary LLC.
 *
 * This software is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this software; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301, USA.
 *
 * Authored by: Corentin Noël <corentin@elementary.io>
 *              Oleksandr Lynok <oleksandr.lynok@gmail.com>
 */

#include "display.h"
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gio/gio.h>
#include <glib-object.h>
#include <glib/gi18n-lib.h>
#include <gee.h>
#include <float.h>
#include <math.h>

#define DISPLAY_DISPLAYS_VIEW_TOUCHSCREEN_SETTINGS_PATH "org.gnome.settings-daemon.peripherals.touchscreen"
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	DISPLAY_DISPLAYS_VIEW_0_PROPERTY,
	DISPLAY_DISPLAYS_VIEW_NUM_PROPERTIES
};
static GParamSpec* display_displays_view_properties[DISPLAY_DISPLAYS_VIEW_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define DISPLAY_DISPLAYS_VIEW_TYPE_SENSOR_PROXY (display_displays_view_sensor_proxy_get_type ())
#define DISPLAY_DISPLAYS_VIEW_SENSOR_PROXY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DISPLAY_DISPLAYS_VIEW_TYPE_SENSOR_PROXY, DisplayDisplaysViewSensorProxy))
#define DISPLAY_DISPLAYS_VIEW_IS_SENSOR_PROXY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DISPLAY_DISPLAYS_VIEW_TYPE_SENSOR_PROXY))
#define DISPLAY_DISPLAYS_VIEW_SENSOR_PROXY_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), DISPLAY_DISPLAYS_VIEW_TYPE_SENSOR_PROXY, DisplayDisplaysViewSensorProxyIface))

typedef struct _DisplayDisplaysViewSensorProxy DisplayDisplaysViewSensorProxy;
typedef struct _DisplayDisplaysViewSensorProxyIface DisplayDisplaysViewSensorProxyIface;

#define DISPLAY_DISPLAYS_VIEW_TYPE_SENSOR_PROXY_PROXY (display_displays_view_sensor_proxy_proxy_get_type ())
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _DisplayDisplaysViewDetectAccelerometerData DisplayDisplaysViewDetectAccelerometerData;
typedef GDBusProxy DisplayDisplaysViewSensorProxyProxy;
typedef GDBusProxyClass DisplayDisplaysViewSensorProxyProxyClass;
typedef struct _Block3Data Block3Data;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_settings_schema_unref0(var) ((var == NULL) ? NULL : (var = (g_settings_schema_unref (var), NULL)))
#define _g_settings_schema_source_unref0(var) ((var == NULL) ? NULL : (var = (g_settings_schema_source_unref (var), NULL)))

struct _DisplayDisplaysViewPrivate {
	GtkComboBoxText* dpi_combo;
	GtkGrid* rotation_lock_grid;
};

struct _DisplayDisplaysViewSensorProxyIface {
	GTypeInterface parent_iface;
	gboolean (*get_has_accelerometer) (DisplayDisplaysViewSensorProxy* self);
};

struct _DisplayDisplaysViewDetectAccelerometerData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	DisplayDisplaysView* self;
	gboolean has_accelerometer;
	DisplayDisplaysViewSensorProxy* sensors;
	DisplayDisplaysViewSensorProxy* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	GError* e;
	GError* _tmp3_;
	const gchar* _tmp4_;
	GSettings* touchscreen_settings;
	GSettings* _tmp5_;
	GtkLabel* rotation_lock_label;
	GtkLabel* _tmp6_;
	GtkSwitch* rotation_lock_switch;
	GtkSwitch* _tmp7_;
	GtkGrid* _tmp8_;
	GtkLabel* _tmp9_;
	GtkGrid* _tmp10_;
	GtkSwitch* _tmp11_;
	GSettings* _tmp12_;
	GtkSwitch* _tmp13_;
	GtkGrid* _tmp14_;
	GError* _inner_error0_;
};

struct _Block3Data {
	int _ref_count_;
	DisplayDisplaysView* self;
	GtkSwitch* mirror_switch;
	GtkGrid* mirror_grid;
	GtkButton* apply_button;
	DisplayMonitorManager* monitor_manager;
};

static gint DisplayDisplaysView_private_offset;
static gpointer display_displays_view_parent_class = NULL;

static void display_displays_view_detect_accelerometer_data_free (gpointer _data);
static void display_displays_view_detect_accelerometer (DisplayDisplaysView* self,
                                                 GAsyncReadyCallback _callback_,
                                                 gpointer _user_data_);
static void display_displays_view_detect_accelerometer_finish (DisplayDisplaysView* self,
                                                        GAsyncResult* _res_);
static gboolean display_displays_view_detect_accelerometer_co (DisplayDisplaysViewDetectAccelerometerData* _data_);
static GType display_displays_view_sensor_proxy_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
VALA_EXTERN GType display_displays_view_sensor_proxy_proxy_get_type (void) G_GNUC_CONST ;
static guint display_displays_view_sensor_proxy_register_object (void* object,
                                                          GDBusConnection* connection,
                                                          const gchar* path,
                                                          GError** error);
static void display_displays_view_detect_accelerometer_ready (GObject* source_object,
                                                       GAsyncResult* _res_,
                                                       gpointer _user_data_);
VALA_EXTERN gboolean display_displays_view_sensor_proxy_get_has_accelerometer (DisplayDisplaysViewSensorProxy* self);
static GType display_displays_view_sensor_proxy_get_type_once (void);
static void display_displays_view_sensor_proxy_proxy_g_signal (GDBusProxy* proxy,
                                                        const gchar* sender_name,
                                                        const gchar* signal_name,
                                                        GVariant* parameters);
static gboolean display_displays_view_sensor_proxy_dbus_proxy_get_has_accelerometer (DisplayDisplaysViewSensorProxy* self);
static void display_displays_view_sensor_proxy_proxy_display_displays_view_sensor_proxy_interface_init (DisplayDisplaysViewSensorProxyIface* iface);
static void display_displays_view_sensor_proxy_dbus_interface_method_call (GDBusConnection* connection,
                                                                    const gchar* sender,
                                                                    const gchar* object_path,
                                                                    const gchar* interface_name,
                                                                    const gchar* method_name,
                                                                    GVariant* parameters,
                                                                    GDBusMethodInvocation* invocation,
                                                                    gpointer user_data);
static GVariant* display_displays_view_sensor_proxy_dbus_interface_get_property (GDBusConnection* connection,
                                                                          const gchar* sender,
                                                                          const gchar* object_path,
                                                                          const gchar* interface_name,
                                                                          const gchar* property_name,
                                                                          GError** error,
                                                                          gpointer user_data);
static GVariant* _dbus_display_displays_view_sensor_proxy_get_has_accelerometer (DisplayDisplaysViewSensorProxy* self);
static gboolean display_displays_view_sensor_proxy_dbus_interface_set_property (GDBusConnection* connection,
                                                                         const gchar* sender,
                                                                         const gchar* object_path,
                                                                         const gchar* interface_name,
                                                                         const gchar* property_name,
                                                                         GVariant* value,
                                                                         GError** error,
                                                                         gpointer user_data);
static void _display_displays_view_sensor_proxy_unregister_object (gpointer user_data);
static GObject * display_displays_view_constructor (GType type,
                                             guint n_construct_properties,
                                             GObjectConstructParam * construct_properties);
static Block3Data* block3_data_ref (Block3Data* _data3_);
static void block3_data_unref (void * _userdata_);
static void _display_displays_view___lambda27_ (Block3Data* _data3_,
                                         gboolean changed);
static void __display_displays_view___lambda27__display_displays_overlay_configuration_changed (DisplayDisplaysOverlay* _sender,
                                                                                         gboolean changed,
                                                                                         gpointer self);
static void _display_displays_view___lambda28_ (Block3Data* _data3_);
static void __display_displays_view___lambda28__g_object_notify (GObject* _sender,
                                                          GParamSpec* pspec,
                                                          gpointer self);
static void _display_displays_view___lambda29_ (DisplayDisplaysView* self);
static void __display_displays_view___lambda29__gtk_button_clicked (GtkButton* _sender,
                                                             gpointer self);
static void _display_displays_view___lambda30_ (Block3Data* _data3_);
static void __display_displays_view___lambda30__gtk_button_clicked (GtkButton* _sender,
                                                             gpointer self);
static void _display_displays_view___lambda31_ (Block3Data* _data3_);
static void __display_displays_view___lambda31__gtk_combo_box_changed (GtkComboBox* _sender,
                                                                gpointer self);
static void _display_displays_view___lambda32_ (Block3Data* _data3_);
static void __display_displays_view___lambda32__g_object_notify (GObject* _sender,
                                                          GParamSpec* pspec,
                                                          gpointer self);
static void display_displays_view_finalize (GObject * obj);
static GType display_displays_view_get_type_once (void);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static const GDBusMethodInfo * const _display_displays_view_sensor_proxy_dbus_method_info[] = {NULL};
static const GDBusSignalInfo * const _display_displays_view_sensor_proxy_dbus_signal_info[] = {NULL};
static const GDBusPropertyInfo _display_displays_view_sensor_proxy_dbus_property_info_has_accelerometer = {-1, "HasAccelerometer", "b", G_DBUS_PROPERTY_INFO_FLAGS_READABLE, NULL};
static const GDBusPropertyInfo * const _display_displays_view_sensor_proxy_dbus_property_info[] = {&_display_displays_view_sensor_proxy_dbus_property_info_has_accelerometer, NULL};
static const GDBusInterfaceInfo _display_displays_view_sensor_proxy_dbus_interface_info = {-1, "net.hadess.SensorProxy", (GDBusMethodInfo **) (&_display_displays_view_sensor_proxy_dbus_method_info), (GDBusSignalInfo **) (&_display_displays_view_sensor_proxy_dbus_signal_info), (GDBusPropertyInfo **) (&_display_displays_view_sensor_proxy_dbus_property_info), NULL};
static const GDBusInterfaceVTable _display_displays_view_sensor_proxy_dbus_interface_vtable = {display_displays_view_sensor_proxy_dbus_interface_method_call, display_displays_view_sensor_proxy_dbus_interface_get_property, display_displays_view_sensor_proxy_dbus_interface_set_property};

static inline gpointer
display_displays_view_get_instance_private (DisplayDisplaysView* self)
{
	return G_STRUCT_MEMBER_P (self, DisplayDisplaysView_private_offset);
}

static void
display_displays_view_detect_accelerometer_data_free (gpointer _data)
{
	DisplayDisplaysViewDetectAccelerometerData* _data_;
	_data_ = _data;
#line 23 "../src/Views/DisplaysView.vala"
	_g_object_unref0 (_data_->self);
#line 23 "../src/Views/DisplaysView.vala"
	g_slice_free (DisplayDisplaysViewDetectAccelerometerData, _data_);
#line 229 "DisplaysView.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 23 "../src/Views/DisplaysView.vala"
	return self ? g_object_ref (self) : NULL;
#line 237 "DisplaysView.c"
}

static void
display_displays_view_detect_accelerometer (DisplayDisplaysView* self,
                                            GAsyncReadyCallback _callback_,
                                            gpointer _user_data_)
{
	DisplayDisplaysViewDetectAccelerometerData* _data_;
	DisplayDisplaysView* _tmp0_;
#line 23 "../src/Views/DisplaysView.vala"
	g_return_if_fail (self != NULL);
#line 23 "../src/Views/DisplaysView.vala"
	_data_ = g_slice_new0 (DisplayDisplaysViewDetectAccelerometerData);
#line 23 "../src/Views/DisplaysView.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 23 "../src/Views/DisplaysView.vala"
	g_task_set_task_data (_data_->_async_result, _data_, display_displays_view_detect_accelerometer_data_free);
#line 23 "../src/Views/DisplaysView.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 23 "../src/Views/DisplaysView.vala"
	_data_->self = _tmp0_;
#line 23 "../src/Views/DisplaysView.vala"
	display_displays_view_detect_accelerometer_co (_data_);
#line 261 "DisplaysView.c"
}

static void
display_displays_view_detect_accelerometer_finish (DisplayDisplaysView* self,
                                                   GAsyncResult* _res_)
{
	DisplayDisplaysViewDetectAccelerometerData* _data_;
#line 23 "../src/Views/DisplaysView.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 271 "DisplaysView.c"
}

static void
display_displays_view_detect_accelerometer_ready (GObject* source_object,
                                                  GAsyncResult* _res_,
                                                  gpointer _user_data_)
{
	DisplayDisplaysViewDetectAccelerometerData* _data_;
#line 140 "../src/Views/DisplaysView.vala"
	_data_ = _user_data_;
#line 140 "../src/Views/DisplaysView.vala"
	_data_->_source_object_ = source_object;
#line 140 "../src/Views/DisplaysView.vala"
	_data_->_res_ = _res_;
#line 140 "../src/Views/DisplaysView.vala"
	display_displays_view_detect_accelerometer_co (_data_);
#line 288 "DisplaysView.c"
}

static gboolean
display_displays_view_detect_accelerometer_co (DisplayDisplaysViewDetectAccelerometerData* _data_)
{
#line 136 "../src/Views/DisplaysView.vala"
	switch (_data_->_state_) {
#line 136 "../src/Views/DisplaysView.vala"
		case 0:
#line 298 "DisplaysView.c"
		goto _state_0;
#line 136 "../src/Views/DisplaysView.vala"
		case 1:
#line 302 "DisplaysView.c"
		goto _state_1;
		default:
#line 136 "../src/Views/DisplaysView.vala"
		g_assert_not_reached ();
#line 307 "DisplaysView.c"
	}
	_state_0:
#line 137 "../src/Views/DisplaysView.vala"
	_data_->has_accelerometer = FALSE;
#line 312 "DisplaysView.c"
	{
#line 140 "../src/Views/DisplaysView.vala"
		_data_->_state_ = 1;
#line 140 "../src/Views/DisplaysView.vala"
		g_async_initable_new_async (DISPLAY_DISPLAYS_VIEW_TYPE_SENSOR_PROXY_PROXY, 0, NULL, display_displays_view_detect_accelerometer_ready, _data_, "g-flags", 0, "g-name", "net.hadess.SensorProxy", "g-bus-type", G_BUS_TYPE_SYSTEM, "g-object-path", "/net/hadess/SensorProxy", "g-interface-name", "net.hadess.SensorProxy", NULL);
#line 140 "../src/Views/DisplaysView.vala"
		return FALSE;
#line 320 "DisplaysView.c"
		_state_1:
#line 140 "../src/Views/DisplaysView.vala"
		_data_->_tmp0_ = (DisplayDisplaysViewSensorProxy*) g_async_initable_new_finish ((GAsyncInitable *) _data_->_source_object_, _data_->_res_, &_data_->_inner_error0_);
#line 140 "../src/Views/DisplaysView.vala"
		_data_->sensors = (DisplayDisplaysViewSensorProxy*) _data_->_tmp0_;
#line 140 "../src/Views/DisplaysView.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 328 "DisplaysView.c"
			goto __catch0_g_error;
		}
#line 141 "../src/Views/DisplaysView.vala"
		_data_->_tmp1_ = display_displays_view_sensor_proxy_get_has_accelerometer (_data_->sensors);
#line 141 "../src/Views/DisplaysView.vala"
		_data_->_tmp2_ = _data_->_tmp1_;
#line 141 "../src/Views/DisplaysView.vala"
		_data_->has_accelerometer = _data_->_tmp2_;
#line 139 "../src/Views/DisplaysView.vala"
		_g_object_unref0 (_data_->sensors);
#line 339 "DisplaysView.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 139 "../src/Views/DisplaysView.vala"
		_data_->e = _data_->_inner_error0_;
#line 139 "../src/Views/DisplaysView.vala"
		_data_->_inner_error0_ = NULL;
#line 143 "../src/Views/DisplaysView.vala"
		_data_->_tmp3_ = _data_->e;
#line 143 "../src/Views/DisplaysView.vala"
		_data_->_tmp4_ = _data_->_tmp3_->message;
#line 143 "../src/Views/DisplaysView.vala"
		g_info ("DisplaysView.vala:143: Unable to connect to SensorProxy bus, probably " \
"means no accelerometer supported: %s", _data_->_tmp4_);
#line 139 "../src/Views/DisplaysView.vala"
		_g_error_free0 (_data_->e);
#line 356 "DisplaysView.c"
	}
	__finally0:
#line 139 "../src/Views/DisplaysView.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 139 "../src/Views/DisplaysView.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 139 "../src/Views/DisplaysView.vala"
		g_clear_error (&_data_->_inner_error0_);
#line 139 "../src/Views/DisplaysView.vala"
		g_object_unref (_data_->_async_result);
#line 139 "../src/Views/DisplaysView.vala"
		return FALSE;
#line 369 "DisplaysView.c"
	}
#line 146 "../src/Views/DisplaysView.vala"
	if (_data_->has_accelerometer) {
#line 147 "../src/Views/DisplaysView.vala"
		_data_->_tmp5_ = g_settings_new (DISPLAY_DISPLAYS_VIEW_TOUCHSCREEN_SETTINGS_PATH);
#line 147 "../src/Views/DisplaysView.vala"
		_data_->touchscreen_settings = _data_->_tmp5_;
#line 149 "../src/Views/DisplaysView.vala"
		_data_->_tmp6_ = (GtkLabel*) gtk_label_new (_ ("Rotation Lock:"));
#line 149 "../src/Views/DisplaysView.vala"
		g_object_ref_sink (_data_->_tmp6_);
#line 149 "../src/Views/DisplaysView.vala"
		_data_->rotation_lock_label = _data_->_tmp6_;
#line 150 "../src/Views/DisplaysView.vala"
		_data_->_tmp7_ = (GtkSwitch*) gtk_switch_new ();
#line 150 "../src/Views/DisplaysView.vala"
		g_object_ref_sink (_data_->_tmp7_);
#line 150 "../src/Views/DisplaysView.vala"
		_data_->rotation_lock_switch = _data_->_tmp7_;
#line 152 "../src/Views/DisplaysView.vala"
		_data_->_tmp8_ = _data_->self->priv->rotation_lock_grid;
#line 152 "../src/Views/DisplaysView.vala"
		_data_->_tmp9_ = _data_->rotation_lock_label;
#line 152 "../src/Views/DisplaysView.vala"
		gtk_container_add ((GtkContainer*) _data_->_tmp8_, (GtkWidget*) _data_->_tmp9_);
#line 153 "../src/Views/DisplaysView.vala"
		_data_->_tmp10_ = _data_->self->priv->rotation_lock_grid;
#line 153 "../src/Views/DisplaysView.vala"
		_data_->_tmp11_ = _data_->rotation_lock_switch;
#line 153 "../src/Views/DisplaysView.vala"
		gtk_container_add ((GtkContainer*) _data_->_tmp10_, (GtkWidget*) _data_->_tmp11_);
#line 155 "../src/Views/DisplaysView.vala"
		_data_->_tmp12_ = _data_->touchscreen_settings;
#line 155 "../src/Views/DisplaysView.vala"
		_data_->_tmp13_ = _data_->rotation_lock_switch;
#line 155 "../src/Views/DisplaysView.vala"
		g_settings_bind (_data_->_tmp12_, "orientation-lock", (GObject*) _data_->_tmp13_, "state", G_SETTINGS_BIND_DEFAULT);
#line 157 "../src/Views/DisplaysView.vala"
		_data_->_tmp14_ = _data_->self->priv->rotation_lock_grid;
#line 157 "../src/Views/DisplaysView.vala"
		gtk_widget_show_all ((GtkWidget*) _data_->_tmp14_);
#line 146 "../src/Views/DisplaysView.vala"
		_g_object_unref0 (_data_->rotation_lock_switch);
#line 146 "../src/Views/DisplaysView.vala"
		_g_object_unref0 (_data_->rotation_lock_label);
#line 146 "../src/Views/DisplaysView.vala"
		_g_object_unref0 (_data_->touchscreen_settings);
#line 417 "DisplaysView.c"
	}
#line 136 "../src/Views/DisplaysView.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 136 "../src/Views/DisplaysView.vala"
	if (_data_->_state_ != 0) {
#line 136 "../src/Views/DisplaysView.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 136 "../src/Views/DisplaysView.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 427 "DisplaysView.c"
		}
	}
#line 136 "../src/Views/DisplaysView.vala"
	g_object_unref (_data_->_async_result);
#line 136 "../src/Views/DisplaysView.vala"
	return FALSE;
#line 434 "DisplaysView.c"
}

DisplayDisplaysView*
display_displays_view_construct (GType object_type)
{
	DisplayDisplaysView * self = NULL;
#line 23 "../src/Views/DisplaysView.vala"
	self = (DisplayDisplaysView*) g_object_new (object_type, NULL);
#line 23 "../src/Views/DisplaysView.vala"
	return self;
#line 445 "DisplaysView.c"
}

DisplayDisplaysView*
display_displays_view_new (void)
{
#line 23 "../src/Views/DisplaysView.vala"
	return display_displays_view_construct (DISPLAY_TYPE_DISPLAYS_VIEW);
#line 453 "DisplaysView.c"
}

gboolean
display_displays_view_sensor_proxy_get_has_accelerometer (DisplayDisplaysViewSensorProxy* self)
{
	DisplayDisplaysViewSensorProxyIface* _iface_;
#line 163 "../src/Views/DisplaysView.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 163 "../src/Views/DisplaysView.vala"
	_iface_ = DISPLAY_DISPLAYS_VIEW_SENSOR_PROXY_GET_INTERFACE (self);
#line 163 "../src/Views/DisplaysView.vala"
	if (_iface_->get_has_accelerometer) {
#line 163 "../src/Views/DisplaysView.vala"
		return _iface_->get_has_accelerometer (self);
#line 468 "DisplaysView.c"
	}
#line 163 "../src/Views/DisplaysView.vala"
	return FALSE;
#line 472 "DisplaysView.c"
}

static void
display_displays_view_sensor_proxy_default_init (DisplayDisplaysViewSensorProxyIface * iface,
                                                 gpointer iface_data)
{
}

static GType
display_displays_view_sensor_proxy_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (DisplayDisplaysViewSensorProxyIface), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) display_displays_view_sensor_proxy_default_init, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
	GType display_displays_view_sensor_proxy_type_id;
	display_displays_view_sensor_proxy_type_id = g_type_register_static (G_TYPE_INTERFACE, "DisplayDisplaysViewSensorProxy", &g_define_type_info, 0);
	g_type_interface_add_prerequisite (display_displays_view_sensor_proxy_type_id, g_dbus_proxy_get_type ());
	g_type_set_qdata (display_displays_view_sensor_proxy_type_id, g_quark_from_static_string ("vala-dbus-proxy-type"), (void*) display_displays_view_sensor_proxy_proxy_get_type);
	g_type_set_qdata (display_displays_view_sensor_proxy_type_id, g_quark_from_static_string ("vala-dbus-interface-name"), "net.hadess.SensorProxy");
	g_type_set_qdata (display_displays_view_sensor_proxy_type_id, g_quark_from_static_string ("vala-dbus-interface-info"), (void*) (&_display_displays_view_sensor_proxy_dbus_interface_info));
	g_type_set_qdata (display_displays_view_sensor_proxy_type_id, g_quark_from_static_string ("vala-dbus-register-object"), (void*) display_displays_view_sensor_proxy_register_object);
	return display_displays_view_sensor_proxy_type_id;
}

static GType
display_displays_view_sensor_proxy_get_type (void)
{
	static volatile gsize display_displays_view_sensor_proxy_type_id__once = 0;
	if (g_once_init_enter (&display_displays_view_sensor_proxy_type_id__once)) {
		GType display_displays_view_sensor_proxy_type_id;
		display_displays_view_sensor_proxy_type_id = display_displays_view_sensor_proxy_get_type_once ();
		g_once_init_leave (&display_displays_view_sensor_proxy_type_id__once, display_displays_view_sensor_proxy_type_id);
	}
	return display_displays_view_sensor_proxy_type_id__once;
}

G_DEFINE_TYPE_EXTENDED (DisplayDisplaysViewSensorProxyProxy, display_displays_view_sensor_proxy_proxy, G_TYPE_DBUS_PROXY, 0, G_IMPLEMENT_INTERFACE (DISPLAY_DISPLAYS_VIEW_TYPE_SENSOR_PROXY, display_displays_view_sensor_proxy_proxy_display_displays_view_sensor_proxy_interface_init) )
static void
display_displays_view_sensor_proxy_proxy_class_init (DisplayDisplaysViewSensorProxyProxyClass* klass)
{
#line 23 "../src/Views/DisplaysView.vala"
	G_DBUS_PROXY_CLASS (klass)->g_signal = display_displays_view_sensor_proxy_proxy_g_signal;
#line 513 "DisplaysView.c"
}

static void
display_displays_view_sensor_proxy_proxy_g_signal (GDBusProxy* proxy,
                                                   const gchar* sender_name,
                                                   const gchar* signal_name,
                                                   GVariant* parameters)
{
}

static void
display_displays_view_sensor_proxy_proxy_init (DisplayDisplaysViewSensorProxyProxy* self)
{
#line 23 "../src/Views/DisplaysView.vala"
	g_dbus_proxy_set_interface_info (G_DBUS_PROXY (self), (GDBusInterfaceInfo *) (&_display_displays_view_sensor_proxy_dbus_interface_info));
#line 529 "DisplaysView.c"
}

static gboolean
display_displays_view_sensor_proxy_dbus_proxy_get_has_accelerometer (DisplayDisplaysViewSensorProxy* self)
{
	GVariant *_inner_reply;
	gboolean _result;
#line 23 "../src/Views/DisplaysView.vala"
	_inner_reply = g_dbus_proxy_get_cached_property ((GDBusProxy *) self, "HasAccelerometer");
#line 23 "../src/Views/DisplaysView.vala"
	if (!_inner_reply) {
#line 541 "DisplaysView.c"
		GVariant *_arguments;
		GVariant *_reply;
		GVariantBuilder _arguments_builder;
#line 23 "../src/Views/DisplaysView.vala"
		g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
#line 23 "../src/Views/DisplaysView.vala"
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("net.hadess.SensorProxy"));
#line 23 "../src/Views/DisplaysView.vala"
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("HasAccelerometer"));
#line 23 "../src/Views/DisplaysView.vala"
		_arguments = g_variant_builder_end (&_arguments_builder);
#line 23 "../src/Views/DisplaysView.vala"
		_reply = g_dbus_proxy_call_sync ((GDBusProxy *) self, "org.freedesktop.DBus.Properties.Get", _arguments, G_DBUS_CALL_FLAGS_NONE, -1, NULL, NULL);
#line 23 "../src/Views/DisplaysView.vala"
		if (!_reply) {
#line 557 "DisplaysView.c"
			gboolean _tmp0_ = FALSE;
#line 23 "../src/Views/DisplaysView.vala"
			return _tmp0_;
#line 561 "DisplaysView.c"
		}
#line 23 "../src/Views/DisplaysView.vala"
		g_variant_get (_reply, "(v)", &_inner_reply);
#line 23 "../src/Views/DisplaysView.vala"
		g_variant_unref (_reply);
#line 567 "DisplaysView.c"
	}
#line 23 "../src/Views/DisplaysView.vala"
	_result = g_variant_get_boolean (_inner_reply);
#line 23 "../src/Views/DisplaysView.vala"
	g_variant_unref (_inner_reply);
#line 23 "../src/Views/DisplaysView.vala"
	return _result;
#line 575 "DisplaysView.c"
}

static void
display_displays_view_sensor_proxy_proxy_display_displays_view_sensor_proxy_interface_init (DisplayDisplaysViewSensorProxyIface* iface)
{
#line 23 "../src/Views/DisplaysView.vala"
	iface->get_has_accelerometer = display_displays_view_sensor_proxy_dbus_proxy_get_has_accelerometer;
#line 583 "DisplaysView.c"
}

static void
display_displays_view_sensor_proxy_dbus_interface_method_call (GDBusConnection* connection,
                                                               const gchar* sender,
                                                               const gchar* object_path,
                                                               const gchar* interface_name,
                                                               const gchar* method_name,
                                                               GVariant* parameters,
                                                               GDBusMethodInvocation* invocation,
                                                               gpointer user_data)
{
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
#line 23 "../src/Views/DisplaysView.vala"
	g_object_unref (invocation);
#line 602 "DisplaysView.c"
}

static GVariant*
_dbus_display_displays_view_sensor_proxy_get_has_accelerometer (DisplayDisplaysViewSensorProxy* self)
{
	gboolean result;
	GVariant* _reply;
#line 23 "../src/Views/DisplaysView.vala"
	result = display_displays_view_sensor_proxy_get_has_accelerometer (self);
#line 23 "../src/Views/DisplaysView.vala"
	_reply = g_variant_new_boolean (result);
#line 23 "../src/Views/DisplaysView.vala"
	return _reply;
#line 616 "DisplaysView.c"
}

static GVariant*
display_displays_view_sensor_proxy_dbus_interface_get_property (GDBusConnection* connection,
                                                                const gchar* sender,
                                                                const gchar* object_path,
                                                                const gchar* interface_name,
                                                                const gchar* property_name,
                                                                GError** error,
                                                                gpointer user_data)
{
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
#line 23 "../src/Views/DisplaysView.vala"
	if (strcmp (property_name, "HasAccelerometer") == 0) {
#line 23 "../src/Views/DisplaysView.vala"
		return _dbus_display_displays_view_sensor_proxy_get_has_accelerometer (object);
#line 636 "DisplaysView.c"
	}
#line 23 "../src/Views/DisplaysView.vala"
	return NULL;
#line 640 "DisplaysView.c"
}

static gboolean
display_displays_view_sensor_proxy_dbus_interface_set_property (GDBusConnection* connection,
                                                                const gchar* sender,
                                                                const gchar* object_path,
                                                                const gchar* interface_name,
                                                                const gchar* property_name,
                                                                GVariant* value,
                                                                GError** error,
                                                                gpointer user_data)
{
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
#line 23 "../src/Views/DisplaysView.vala"
	return FALSE;
#line 659 "DisplaysView.c"
}

static guint
display_displays_view_sensor_proxy_register_object (gpointer object,
                                                    GDBusConnection* connection,
                                                    const gchar* path,
                                                    GError** error)
{
	guint result;
	gpointer *data;
#line 23 "../src/Views/DisplaysView.vala"
	data = g_new (gpointer, 3);
#line 23 "../src/Views/DisplaysView.vala"
	data[0] = g_object_ref (object);
#line 23 "../src/Views/DisplaysView.vala"
	data[1] = g_object_ref (connection);
#line 23 "../src/Views/DisplaysView.vala"
	data[2] = g_strdup (path);
#line 23 "../src/Views/DisplaysView.vala"
	result = g_dbus_connection_register_object (connection, path, (GDBusInterfaceInfo *) (&_display_displays_view_sensor_proxy_dbus_interface_info), &_display_displays_view_sensor_proxy_dbus_interface_vtable, data, _display_displays_view_sensor_proxy_unregister_object, error);
#line 23 "../src/Views/DisplaysView.vala"
	if (!result) {
#line 23 "../src/Views/DisplaysView.vala"
		return 0;
#line 684 "DisplaysView.c"
	}
#line 23 "../src/Views/DisplaysView.vala"
	return result;
#line 688 "DisplaysView.c"
}

static void
_display_displays_view_sensor_proxy_unregister_object (gpointer user_data)
{
	gpointer* data;
	data = user_data;
#line 23 "../src/Views/DisplaysView.vala"
	g_object_unref (data[0]);
#line 23 "../src/Views/DisplaysView.vala"
	g_object_unref (data[1]);
#line 23 "../src/Views/DisplaysView.vala"
	g_free (data[2]);
#line 23 "../src/Views/DisplaysView.vala"
	g_free (data);
#line 704 "DisplaysView.c"
}

static Block3Data*
block3_data_ref (Block3Data* _data3_)
{
#line 31 "../src/Views/DisplaysView.vala"
	g_atomic_int_inc (&_data3_->_ref_count_);
#line 31 "../src/Views/DisplaysView.vala"
	return _data3_;
#line 714 "DisplaysView.c"
}

static void
block3_data_unref (void * _userdata_)
{
	Block3Data* _data3_;
	_data3_ = (Block3Data*) _userdata_;
#line 31 "../src/Views/DisplaysView.vala"
	if (g_atomic_int_dec_and_test (&_data3_->_ref_count_)) {
#line 724 "DisplaysView.c"
		DisplayDisplaysView* self;
#line 31 "../src/Views/DisplaysView.vala"
		self = _data3_->self;
#line 31 "../src/Views/DisplaysView.vala"
		_g_object_unref0 (_data3_->apply_button);
#line 31 "../src/Views/DisplaysView.vala"
		_g_object_unref0 (_data3_->mirror_grid);
#line 31 "../src/Views/DisplaysView.vala"
		_g_object_unref0 (_data3_->mirror_switch);
#line 31 "../src/Views/DisplaysView.vala"
		_g_object_unref0 (self);
#line 31 "../src/Views/DisplaysView.vala"
		g_slice_free (Block3Data, _data3_);
#line 738 "DisplaysView.c"
	}
}

static gpointer
_g_settings_schema_source_ref0 (gpointer self)
{
#line 79 "../src/Views/DisplaysView.vala"
	return self ? g_settings_schema_source_ref (self) : NULL;
#line 747 "DisplaysView.c"
}

static void
_display_displays_view___lambda27_ (Block3Data* _data3_,
                                    gboolean changed)
{
	DisplayDisplaysView* self;
	GtkButton* _tmp0_;
#line 102 "../src/Views/DisplaysView.vala"
	self = _data3_->self;
#line 103 "../src/Views/DisplaysView.vala"
	_tmp0_ = _data3_->apply_button;
#line 103 "../src/Views/DisplaysView.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp0_, changed);
#line 762 "DisplaysView.c"
}

static void
__display_displays_view___lambda27__display_displays_overlay_configuration_changed (DisplayDisplaysOverlay* _sender,
                                                                                    gboolean changed,
                                                                                    gpointer self)
{
#line 102 "../src/Views/DisplaysView.vala"
	_display_displays_view___lambda27_ (self, changed);
#line 772 "DisplaysView.c"
}

static void
_display_displays_view___lambda28_ (Block3Data* _data3_)
{
	DisplayDisplaysView* self;
	GtkGrid* _tmp0_;
	DisplayMonitorManager* _tmp1_;
	GeeLinkedList* _tmp2_;
	GeeLinkedList* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
#line 108 "../src/Views/DisplaysView.vala"
	self = _data3_->self;
#line 109 "../src/Views/DisplaysView.vala"
	_tmp0_ = _data3_->mirror_grid;
#line 109 "../src/Views/DisplaysView.vala"
	_tmp1_ = _data3_->monitor_manager;
#line 109 "../src/Views/DisplaysView.vala"
	_tmp2_ = display_monitor_manager_get_monitors (_tmp1_);
#line 109 "../src/Views/DisplaysView.vala"
	_tmp3_ = _tmp2_;
#line 109 "../src/Views/DisplaysView.vala"
	_tmp4_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp3_);
#line 109 "../src/Views/DisplaysView.vala"
	_tmp5_ = _tmp4_;
#line 109 "../src/Views/DisplaysView.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp0_, _tmp5_ > 1);
#line 801 "DisplaysView.c"
}

static void
__display_displays_view___lambda28__g_object_notify (GObject* _sender,
                                                     GParamSpec* pspec,
                                                     gpointer self)
{
#line 108 "../src/Views/DisplaysView.vala"
	_display_displays_view___lambda28_ (self);
#line 811 "DisplaysView.c"
}

static void
_display_displays_view___lambda29_ (DisplayDisplaysView* self)
{
	DisplayDisplaysOverlay* _tmp0_;
#line 112 "../src/Views/DisplaysView.vala"
	_tmp0_ = self->displays_overlay;
#line 112 "../src/Views/DisplaysView.vala"
	display_displays_overlay_rescan_displays (_tmp0_);
#line 822 "DisplaysView.c"
}

static void
__display_displays_view___lambda29__gtk_button_clicked (GtkButton* _sender,
                                                        gpointer self)
{
#line 112 "../src/Views/DisplaysView.vala"
	_display_displays_view___lambda29_ ((DisplayDisplaysView*) self);
#line 831 "DisplaysView.c"
}

static void
_display_displays_view___lambda30_ (Block3Data* _data3_)
{
	DisplayDisplaysView* self;
	DisplayMonitorManager* _tmp0_;
	GtkButton* _tmp1_;
#line 113 "../src/Views/DisplaysView.vala"
	self = _data3_->self;
#line 114 "../src/Views/DisplaysView.vala"
	_tmp0_ = _data3_->monitor_manager;
#line 114 "../src/Views/DisplaysView.vala"
	display_monitor_manager_set_monitor_config (_tmp0_);
#line 115 "../src/Views/DisplaysView.vala"
	_tmp1_ = _data3_->apply_button;
#line 115 "../src/Views/DisplaysView.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp1_, FALSE);
#line 850 "DisplaysView.c"
}

static void
__display_displays_view___lambda30__gtk_button_clicked (GtkButton* _sender,
                                                        gpointer self)
{
#line 113 "../src/Views/DisplaysView.vala"
	_display_displays_view___lambda30_ (self);
#line 859 "DisplaysView.c"
}

static void
_display_displays_view___lambda31_ (Block3Data* _data3_)
{
	DisplayDisplaysView* self;
	DisplayMonitorManager* _tmp0_;
	GtkComboBoxText* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
#line 120 "../src/Views/DisplaysView.vala"
	self = _data3_->self;
#line 121 "../src/Views/DisplaysView.vala"
	_tmp0_ = _data3_->monitor_manager;
#line 121 "../src/Views/DisplaysView.vala"
	_tmp1_ = self->priv->dpi_combo;
#line 121 "../src/Views/DisplaysView.vala"
	_tmp2_ = gtk_combo_box_get_active ((GtkComboBox*) _tmp1_);
#line 121 "../src/Views/DisplaysView.vala"
	_tmp3_ = _tmp2_;
#line 121 "../src/Views/DisplaysView.vala"
	display_monitor_manager_set_scale_on_all_monitors (_tmp0_, (gdouble) (_tmp3_ + 1));
#line 882 "DisplaysView.c"
}

static void
__display_displays_view___lambda31__gtk_combo_box_changed (GtkComboBox* _sender,
                                                           gpointer self)
{
#line 120 "../src/Views/DisplaysView.vala"
	_display_displays_view___lambda31_ (self);
#line 891 "DisplaysView.c"
}

static void
_display_displays_view___lambda32_ (Block3Data* _data3_)
{
	DisplayDisplaysView* self;
	GtkSwitch* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	GtkButton* _tmp5_;
#line 125 "../src/Views/DisplaysView.vala"
	self = _data3_->self;
#line 126 "../src/Views/DisplaysView.vala"
	_tmp0_ = _data3_->mirror_switch;
#line 126 "../src/Views/DisplaysView.vala"
	_tmp1_ = gtk_switch_get_active (_tmp0_);
#line 126 "../src/Views/DisplaysView.vala"
	_tmp2_ = _tmp1_;
#line 126 "../src/Views/DisplaysView.vala"
	if (_tmp2_) {
#line 912 "DisplaysView.c"
		DisplayMonitorManager* _tmp3_;
#line 127 "../src/Views/DisplaysView.vala"
		_tmp3_ = _data3_->monitor_manager;
#line 127 "../src/Views/DisplaysView.vala"
		display_monitor_manager_enable_clone_mode (_tmp3_);
#line 918 "DisplaysView.c"
	} else {
		DisplayMonitorManager* _tmp4_;
#line 129 "../src/Views/DisplaysView.vala"
		_tmp4_ = _data3_->monitor_manager;
#line 129 "../src/Views/DisplaysView.vala"
		display_monitor_manager_disable_clone_mode (_tmp4_);
#line 925 "DisplaysView.c"
	}
#line 132 "../src/Views/DisplaysView.vala"
	_tmp5_ = _data3_->apply_button;
#line 132 "../src/Views/DisplaysView.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp5_, TRUE);
#line 931 "DisplaysView.c"
}

static void
__display_displays_view___lambda32__g_object_notify (GObject* _sender,
                                                     GParamSpec* pspec,
                                                     gpointer self)
{
#line 125 "../src/Views/DisplaysView.vala"
	_display_displays_view___lambda32_ (self);
#line 941 "DisplaysView.c"
}

static GObject *
display_displays_view_constructor (GType type,
                                   guint n_construct_properties,
                                   GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	DisplayDisplaysView * self;
	Block3Data* _data3_;
	DisplayDisplaysOverlay* _tmp0_;
	GtkLabel* mirror_label = NULL;
	GtkLabel* _tmp1_;
	GtkSwitch* _tmp2_;
	GtkGrid* _tmp3_ = NULL;
	GtkGrid* _tmp4_;
	GtkLabel* _tmp5_;
	GtkGrid* _tmp6_;
	GtkSwitch* _tmp7_;
	GtkLabel* dpi_label = NULL;
	GtkLabel* _tmp8_;
	GtkComboBoxText* _tmp9_;
	GtkComboBoxText* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	GtkComboBoxText* _tmp13_;
	gchar* _tmp14_;
	gchar* _tmp15_;
	GtkComboBoxText* _tmp16_;
	gchar* _tmp17_;
	gchar* _tmp18_;
	GtkGrid* dpi_grid = NULL;
	GtkGrid* _tmp19_ = NULL;
	GtkGrid* _tmp20_;
	GtkLabel* _tmp21_;
	GtkGrid* _tmp22_;
	GtkComboBoxText* _tmp23_;
	GtkButton* detect_button = NULL;
	GtkButton* _tmp24_;
	GtkButton* _tmp25_;
	GtkButton* _tmp26_;
	GtkStyleContext* _tmp27_;
	GtkButton* _tmp28_;
	GtkGrid* button_grid = NULL;
	GtkGrid* _tmp29_ = NULL;
	GtkGrid* _tmp30_;
	GtkButton* _tmp31_;
	GtkGrid* _tmp32_;
	GtkButton* _tmp33_;
	GtkActionBar* action_bar = NULL;
	GtkActionBar* _tmp34_;
	GtkActionBar* _tmp35_;
	GtkStyleContext* _tmp36_;
	GtkActionBar* _tmp37_;
	GtkGrid* _tmp38_;
	GtkActionBar* _tmp39_;
	GtkGrid* _tmp40_;
	GSettingsSchemaSource* schema_source = NULL;
	GSettingsSchemaSource* _tmp41_;
	GSettingsSchemaSource* _tmp42_;
	GSettingsSchema* rotation_lock_schema = NULL;
	GSettingsSchemaSource* _tmp43_;
	GSettingsSchema* _tmp44_;
	GSettingsSchema* _tmp45_;
	GtkActionBar* _tmp49_;
	GtkGrid* _tmp50_;
	GtkSeparator* _tmp51_;
	GtkSeparator* _tmp52_;
	DisplayDisplaysOverlay* _tmp53_;
	GtkActionBar* _tmp54_;
	DisplayDisplaysOverlay* _tmp55_;
	DisplayMonitorManager* _tmp56_;
	GtkGrid* _tmp57_;
	DisplayMonitorManager* _tmp58_;
	GeeLinkedList* _tmp59_;
	GeeLinkedList* _tmp60_;
	gint _tmp61_;
	gint _tmp62_;
	DisplayMonitorManager* _tmp63_;
	GtkButton* _tmp64_;
	GtkButton* _tmp65_;
	GtkComboBoxText* _tmp66_;
	DisplayMonitorManager* _tmp67_;
	GeeLinkedList* _tmp68_;
	GeeLinkedList* _tmp69_;
	gpointer _tmp70_;
	DisplayVirtualMonitor* _tmp71_;
	gdouble _tmp72_;
	gdouble _tmp73_;
	GtkComboBoxText* _tmp74_;
	GtkSwitch* _tmp75_;
	DisplayMonitorManager* _tmp76_;
	gboolean _tmp77_;
	gboolean _tmp78_;
	GtkSwitch* _tmp79_;
#line 31 "../src/Views/DisplaysView.vala"
	parent_class = G_OBJECT_CLASS (display_displays_view_parent_class);
#line 31 "../src/Views/DisplaysView.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 31 "../src/Views/DisplaysView.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, DISPLAY_TYPE_DISPLAYS_VIEW, DisplayDisplaysView);
#line 31 "../src/Views/DisplaysView.vala"
	_data3_ = g_slice_new0 (Block3Data);
#line 31 "../src/Views/DisplaysView.vala"
	_data3_->_ref_count_ = 1;
#line 31 "../src/Views/DisplaysView.vala"
	_data3_->self = g_object_ref (self);
#line 32 "../src/Views/DisplaysView.vala"
	_tmp0_ = display_displays_overlay_new ();
#line 32 "../src/Views/DisplaysView.vala"
	g_object_ref_sink (_tmp0_);
#line 32 "../src/Views/DisplaysView.vala"
	_g_object_unref0 (self->displays_overlay);
#line 32 "../src/Views/DisplaysView.vala"
	self->displays_overlay = _tmp0_;
#line 34 "../src/Views/DisplaysView.vala"
	_tmp1_ = (GtkLabel*) gtk_label_new (_ ("Mirror Display:"));
#line 34 "../src/Views/DisplaysView.vala"
	g_object_ref_sink (_tmp1_);
#line 34 "../src/Views/DisplaysView.vala"
	mirror_label = _tmp1_;
#line 35 "../src/Views/DisplaysView.vala"
	_tmp2_ = (GtkSwitch*) gtk_switch_new ();
#line 35 "../src/Views/DisplaysView.vala"
	g_object_ref_sink (_tmp2_);
#line 35 "../src/Views/DisplaysView.vala"
	_data3_->mirror_switch = _tmp2_;
#line 37 "../src/Views/DisplaysView.vala"
	_tmp3_ = (GtkGrid*) gtk_grid_new ();
#line 37 "../src/Views/DisplaysView.vala"
	gtk_grid_set_column_spacing (_tmp3_, 6);
#line 37 "../src/Views/DisplaysView.vala"
	g_object_set ((GtkWidget*) _tmp3_, "margin", 6, NULL);
#line 37 "../src/Views/DisplaysView.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp3_, GTK_ALIGN_CENTER);
#line 37 "../src/Views/DisplaysView.vala"
	g_object_ref_sink (_tmp3_);
#line 37 "../src/Views/DisplaysView.vala"
	_data3_->mirror_grid = _tmp3_;
#line 42 "../src/Views/DisplaysView.vala"
	_tmp4_ = _data3_->mirror_grid;
#line 42 "../src/Views/DisplaysView.vala"
	_tmp5_ = mirror_label;
#line 42 "../src/Views/DisplaysView.vala"
	gtk_container_add ((GtkContainer*) _tmp4_, (GtkWidget*) _tmp5_);
#line 43 "../src/Views/DisplaysView.vala"
	_tmp6_ = _data3_->mirror_grid;
#line 43 "../src/Views/DisplaysView.vala"
	_tmp7_ = _data3_->mirror_switch;
#line 43 "../src/Views/DisplaysView.vala"
	gtk_container_add ((GtkContainer*) _tmp6_, (GtkWidget*) _tmp7_);
#line 45 "../src/Views/DisplaysView.vala"
	_tmp8_ = (GtkLabel*) gtk_label_new (_ ("Scaling factor:"));
#line 45 "../src/Views/DisplaysView.vala"
	g_object_ref_sink (_tmp8_);
#line 45 "../src/Views/DisplaysView.vala"
	dpi_label = _tmp8_;
#line 47 "../src/Views/DisplaysView.vala"
	_tmp9_ = (GtkComboBoxText*) gtk_combo_box_text_new ();
#line 47 "../src/Views/DisplaysView.vala"
	g_object_ref_sink (_tmp9_);
#line 47 "../src/Views/DisplaysView.vala"
	_g_object_unref0 (self->priv->dpi_combo);
#line 47 "../src/Views/DisplaysView.vala"
	self->priv->dpi_combo = _tmp9_;
#line 48 "../src/Views/DisplaysView.vala"
	_tmp10_ = self->priv->dpi_combo;
#line 48 "../src/Views/DisplaysView.vala"
	_tmp11_ = g_strconcat (_ ("LoDPI"), " (1×)", NULL);
#line 48 "../src/Views/DisplaysView.vala"
	_tmp12_ = _tmp11_;
#line 48 "../src/Views/DisplaysView.vala"
	gtk_combo_box_text_append_text (_tmp10_, _tmp12_);
#line 48 "../src/Views/DisplaysView.vala"
	_g_free0 (_tmp12_);
#line 49 "../src/Views/DisplaysView.vala"
	_tmp13_ = self->priv->dpi_combo;
#line 49 "../src/Views/DisplaysView.vala"
	_tmp14_ = g_strconcat (_ ("HiDPI"), " (2×)", NULL);
#line 49 "../src/Views/DisplaysView.vala"
	_tmp15_ = _tmp14_;
#line 49 "../src/Views/DisplaysView.vala"
	gtk_combo_box_text_append_text (_tmp13_, _tmp15_);
#line 49 "../src/Views/DisplaysView.vala"
	_g_free0 (_tmp15_);
#line 50 "../src/Views/DisplaysView.vala"
	_tmp16_ = self->priv->dpi_combo;
#line 50 "../src/Views/DisplaysView.vala"
	_tmp17_ = g_strconcat (_ ("HiDPI"), " (3×)", NULL);
#line 50 "../src/Views/DisplaysView.vala"
	_tmp18_ = _tmp17_;
#line 50 "../src/Views/DisplaysView.vala"
	gtk_combo_box_text_append_text (_tmp16_, _tmp18_);
#line 50 "../src/Views/DisplaysView.vala"
	_g_free0 (_tmp18_);
#line 52 "../src/Views/DisplaysView.vala"
	_tmp19_ = (GtkGrid*) gtk_grid_new ();
#line 52 "../src/Views/DisplaysView.vala"
	gtk_grid_set_column_spacing (_tmp19_, 6);
#line 52 "../src/Views/DisplaysView.vala"
	g_object_set ((GtkWidget*) _tmp19_, "margin", 6, NULL);
#line 52 "../src/Views/DisplaysView.vala"
	g_object_ref_sink (_tmp19_);
#line 52 "../src/Views/DisplaysView.vala"
	dpi_grid = _tmp19_;
#line 56 "../src/Views/DisplaysView.vala"
	_tmp20_ = dpi_grid;
#line 56 "../src/Views/DisplaysView.vala"
	_tmp21_ = dpi_label;
#line 56 "../src/Views/DisplaysView.vala"
	gtk_container_add ((GtkContainer*) _tmp20_, (GtkWidget*) _tmp21_);
#line 57 "../src/Views/DisplaysView.vala"
	_tmp22_ = dpi_grid;
#line 57 "../src/Views/DisplaysView.vala"
	_tmp23_ = self->priv->dpi_combo;
#line 57 "../src/Views/DisplaysView.vala"
	gtk_container_add ((GtkContainer*) _tmp22_, (GtkWidget*) _tmp23_);
#line 59 "../src/Views/DisplaysView.vala"
	_tmp24_ = (GtkButton*) gtk_button_new_with_label (_ ("Detect Displays"));
#line 59 "../src/Views/DisplaysView.vala"
	g_object_ref_sink (_tmp24_);
#line 59 "../src/Views/DisplaysView.vala"
	detect_button = _tmp24_;
#line 61 "../src/Views/DisplaysView.vala"
	_tmp25_ = (GtkButton*) gtk_button_new_with_label (_ ("Apply"));
#line 61 "../src/Views/DisplaysView.vala"
	g_object_ref_sink (_tmp25_);
#line 61 "../src/Views/DisplaysView.vala"
	_data3_->apply_button = _tmp25_;
#line 62 "../src/Views/DisplaysView.vala"
	_tmp26_ = _data3_->apply_button;
#line 62 "../src/Views/DisplaysView.vala"
	_tmp27_ = gtk_widget_get_style_context ((GtkWidget*) _tmp26_);
#line 62 "../src/Views/DisplaysView.vala"
	gtk_style_context_add_class (_tmp27_, GTK_STYLE_CLASS_SUGGESTED_ACTION);
#line 63 "../src/Views/DisplaysView.vala"
	_tmp28_ = _data3_->apply_button;
#line 63 "../src/Views/DisplaysView.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp28_, FALSE);
#line 65 "../src/Views/DisplaysView.vala"
	_tmp29_ = (GtkGrid*) gtk_grid_new ();
#line 65 "../src/Views/DisplaysView.vala"
	gtk_grid_set_column_homogeneous (_tmp29_, TRUE);
#line 65 "../src/Views/DisplaysView.vala"
	gtk_grid_set_column_spacing (_tmp29_, 6);
#line 65 "../src/Views/DisplaysView.vala"
	g_object_set ((GtkWidget*) _tmp29_, "margin", 6, NULL);
#line 65 "../src/Views/DisplaysView.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp29_, GTK_ALIGN_CENTER);
#line 65 "../src/Views/DisplaysView.vala"
	g_object_ref_sink (_tmp29_);
#line 65 "../src/Views/DisplaysView.vala"
	button_grid = _tmp29_;
#line 71 "../src/Views/DisplaysView.vala"
	_tmp30_ = button_grid;
#line 71 "../src/Views/DisplaysView.vala"
	_tmp31_ = detect_button;
#line 71 "../src/Views/DisplaysView.vala"
	gtk_container_add ((GtkContainer*) _tmp30_, (GtkWidget*) _tmp31_);
#line 72 "../src/Views/DisplaysView.vala"
	_tmp32_ = button_grid;
#line 72 "../src/Views/DisplaysView.vala"
	_tmp33_ = _data3_->apply_button;
#line 72 "../src/Views/DisplaysView.vala"
	gtk_container_add ((GtkContainer*) _tmp32_, (GtkWidget*) _tmp33_);
#line 74 "../src/Views/DisplaysView.vala"
	_tmp34_ = (GtkActionBar*) gtk_action_bar_new ();
#line 74 "../src/Views/DisplaysView.vala"
	g_object_ref_sink (_tmp34_);
#line 74 "../src/Views/DisplaysView.vala"
	action_bar = _tmp34_;
#line 75 "../src/Views/DisplaysView.vala"
	_tmp35_ = action_bar;
#line 75 "../src/Views/DisplaysView.vala"
	_tmp36_ = gtk_widget_get_style_context ((GtkWidget*) _tmp35_);
#line 75 "../src/Views/DisplaysView.vala"
	gtk_style_context_add_class (_tmp36_, GTK_STYLE_CLASS_FLAT);
#line 76 "../src/Views/DisplaysView.vala"
	_tmp37_ = action_bar;
#line 76 "../src/Views/DisplaysView.vala"
	_tmp38_ = dpi_grid;
#line 76 "../src/Views/DisplaysView.vala"
	gtk_action_bar_pack_start (_tmp37_, (GtkWidget*) _tmp38_);
#line 77 "../src/Views/DisplaysView.vala"
	_tmp39_ = action_bar;
#line 77 "../src/Views/DisplaysView.vala"
	_tmp40_ = _data3_->mirror_grid;
#line 77 "../src/Views/DisplaysView.vala"
	gtk_action_bar_pack_start (_tmp39_, (GtkWidget*) _tmp40_);
#line 79 "../src/Views/DisplaysView.vala"
	_tmp41_ = g_settings_schema_source_get_default ();
#line 79 "../src/Views/DisplaysView.vala"
	_tmp42_ = _g_settings_schema_source_ref0 (_tmp41_);
#line 79 "../src/Views/DisplaysView.vala"
	schema_source = _tmp42_;
#line 80 "../src/Views/DisplaysView.vala"
	_tmp43_ = schema_source;
#line 80 "../src/Views/DisplaysView.vala"
	_tmp44_ = g_settings_schema_source_lookup (_tmp43_, DISPLAY_DISPLAYS_VIEW_TOUCHSCREEN_SETTINGS_PATH, TRUE);
#line 80 "../src/Views/DisplaysView.vala"
	rotation_lock_schema = _tmp44_;
#line 81 "../src/Views/DisplaysView.vala"
	_tmp45_ = rotation_lock_schema;
#line 81 "../src/Views/DisplaysView.vala"
	if (_tmp45_ != NULL) {
#line 1248 "DisplaysView.c"
		GtkGrid* _tmp46_ = NULL;
		GtkActionBar* _tmp47_;
		GtkGrid* _tmp48_;
#line 82 "../src/Views/DisplaysView.vala"
		_tmp46_ = (GtkGrid*) gtk_grid_new ();
#line 82 "../src/Views/DisplaysView.vala"
		gtk_grid_set_column_spacing (_tmp46_, 6);
#line 82 "../src/Views/DisplaysView.vala"
		g_object_set ((GtkWidget*) _tmp46_, "margin", 6, NULL);
#line 82 "../src/Views/DisplaysView.vala"
		gtk_widget_set_valign ((GtkWidget*) _tmp46_, GTK_ALIGN_CENTER);
#line 82 "../src/Views/DisplaysView.vala"
		g_object_ref_sink (_tmp46_);
#line 82 "../src/Views/DisplaysView.vala"
		_g_object_unref0 (self->priv->rotation_lock_grid);
#line 82 "../src/Views/DisplaysView.vala"
		self->priv->rotation_lock_grid = _tmp46_;
#line 88 "../src/Views/DisplaysView.vala"
		_tmp47_ = action_bar;
#line 88 "../src/Views/DisplaysView.vala"
		_tmp48_ = self->priv->rotation_lock_grid;
#line 88 "../src/Views/DisplaysView.vala"
		gtk_action_bar_pack_start (_tmp47_, (GtkWidget*) _tmp48_);
#line 90 "../src/Views/DisplaysView.vala"
		display_displays_view_detect_accelerometer (self, NULL, NULL);
#line 1274 "DisplaysView.c"
	} else {
#line 92 "../src/Views/DisplaysView.vala"
		g_info ("DisplaysView.vala:92: Schema \"org.gnome.settings-daemon.peripherals.t" \
"ouchscreen\" is not installed on your system.");
#line 1278 "DisplaysView.c"
	}
#line 95 "../src/Views/DisplaysView.vala"
	_tmp49_ = action_bar;
#line 95 "../src/Views/DisplaysView.vala"
	_tmp50_ = button_grid;
#line 95 "../src/Views/DisplaysView.vala"
	gtk_action_bar_pack_end (_tmp49_, (GtkWidget*) _tmp50_);
#line 97 "../src/Views/DisplaysView.vala"
	gtk_orientable_set_orientation ((GtkOrientable*) self, GTK_ORIENTATION_VERTICAL);
#line 98 "../src/Views/DisplaysView.vala"
	_tmp51_ = (GtkSeparator*) gtk_separator_new (GTK_ORIENTATION_HORIZONTAL);
#line 98 "../src/Views/DisplaysView.vala"
	g_object_ref_sink (_tmp51_);
#line 98 "../src/Views/DisplaysView.vala"
	_tmp52_ = _tmp51_;
#line 98 "../src/Views/DisplaysView.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp52_);
#line 98 "../src/Views/DisplaysView.vala"
	_g_object_unref0 (_tmp52_);
#line 99 "../src/Views/DisplaysView.vala"
	_tmp53_ = self->displays_overlay;
#line 99 "../src/Views/DisplaysView.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp53_);
#line 100 "../src/Views/DisplaysView.vala"
	_tmp54_ = action_bar;
#line 100 "../src/Views/DisplaysView.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp54_);
#line 102 "../src/Views/DisplaysView.vala"
	_tmp55_ = self->displays_overlay;
#line 102 "../src/Views/DisplaysView.vala"
	g_signal_connect_data (_tmp55_, "configuration-changed", (GCallback) __display_displays_view___lambda27__display_displays_overlay_configuration_changed, block3_data_ref (_data3_), (GClosureNotify) block3_data_unref, 0);
#line 106 "../src/Views/DisplaysView.vala"
	_tmp56_ = display_monitor_manager_get_default ();
#line 106 "../src/Views/DisplaysView.vala"
	_data3_->monitor_manager = _tmp56_;
#line 107 "../src/Views/DisplaysView.vala"
	_tmp57_ = _data3_->mirror_grid;
#line 107 "../src/Views/DisplaysView.vala"
	_tmp58_ = _data3_->monitor_manager;
#line 107 "../src/Views/DisplaysView.vala"
	_tmp59_ = display_monitor_manager_get_monitors (_tmp58_);
#line 107 "../src/Views/DisplaysView.vala"
	_tmp60_ = _tmp59_;
#line 107 "../src/Views/DisplaysView.vala"
	_tmp61_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp60_);
#line 107 "../src/Views/DisplaysView.vala"
	_tmp62_ = _tmp61_;
#line 107 "../src/Views/DisplaysView.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp57_, _tmp62_ > 1);
#line 108 "../src/Views/DisplaysView.vala"
	_tmp63_ = _data3_->monitor_manager;
#line 108 "../src/Views/DisplaysView.vala"
	g_signal_connect_data ((GObject*) _tmp63_, "notify::monitor-number", (GCallback) __display_displays_view___lambda28__g_object_notify, block3_data_ref (_data3_), (GClosureNotify) block3_data_unref, 0);
#line 112 "../src/Views/DisplaysView.vala"
	_tmp64_ = detect_button;
#line 112 "../src/Views/DisplaysView.vala"
	g_signal_connect_object (_tmp64_, "clicked", (GCallback) __display_displays_view___lambda29__gtk_button_clicked, self, 0);
#line 113 "../src/Views/DisplaysView.vala"
	_tmp65_ = _data3_->apply_button;
#line 113 "../src/Views/DisplaysView.vala"
	g_signal_connect_data (_tmp65_, "clicked", (GCallback) __display_displays_view___lambda30__gtk_button_clicked, block3_data_ref (_data3_), (GClosureNotify) block3_data_unref, 0);
#line 118 "../src/Views/DisplaysView.vala"
	_tmp66_ = self->priv->dpi_combo;
#line 118 "../src/Views/DisplaysView.vala"
	_tmp67_ = _data3_->monitor_manager;
#line 118 "../src/Views/DisplaysView.vala"
	_tmp68_ = display_monitor_manager_get_virtual_monitors (_tmp67_);
#line 118 "../src/Views/DisplaysView.vala"
	_tmp69_ = _tmp68_;
#line 118 "../src/Views/DisplaysView.vala"
	_tmp70_ = gee_abstract_list_get ((GeeAbstractList*) _tmp69_, 0);
#line 118 "../src/Views/DisplaysView.vala"
	_tmp71_ = (DisplayVirtualMonitor*) _tmp70_;
#line 118 "../src/Views/DisplaysView.vala"
	_tmp72_ = display_virtual_monitor_get_scale (_tmp71_);
#line 118 "../src/Views/DisplaysView.vala"
	_tmp73_ = _tmp72_;
#line 118 "../src/Views/DisplaysView.vala"
	gtk_combo_box_set_active ((GtkComboBox*) _tmp66_, ((gint) _tmp73_) - 1);
#line 118 "../src/Views/DisplaysView.vala"
	_g_object_unref0 (_tmp71_);
#line 120 "../src/Views/DisplaysView.vala"
	_tmp74_ = self->priv->dpi_combo;
#line 120 "../src/Views/DisplaysView.vala"
	g_signal_connect_data ((GtkComboBox*) _tmp74_, "changed", (GCallback) __display_displays_view___lambda31__gtk_combo_box_changed, block3_data_ref (_data3_), (GClosureNotify) block3_data_unref, 0);
#line 124 "../src/Views/DisplaysView.vala"
	_tmp75_ = _data3_->mirror_switch;
#line 124 "../src/Views/DisplaysView.vala"
	_tmp76_ = _data3_->monitor_manager;
#line 124 "../src/Views/DisplaysView.vala"
	_tmp77_ = display_monitor_manager_get_is_mirrored (_tmp76_);
#line 124 "../src/Views/DisplaysView.vala"
	_tmp78_ = _tmp77_;
#line 124 "../src/Views/DisplaysView.vala"
	gtk_switch_set_active (_tmp75_, _tmp78_);
#line 125 "../src/Views/DisplaysView.vala"
	_tmp79_ = _data3_->mirror_switch;
#line 125 "../src/Views/DisplaysView.vala"
	g_signal_connect_data ((GObject*) _tmp79_, "notify::active", (GCallback) __display_displays_view___lambda32__g_object_notify, block3_data_ref (_data3_), (GClosureNotify) block3_data_unref, 0);
#line 31 "../src/Views/DisplaysView.vala"
	_g_settings_schema_unref0 (rotation_lock_schema);
#line 31 "../src/Views/DisplaysView.vala"
	_g_settings_schema_source_unref0 (schema_source);
#line 31 "../src/Views/DisplaysView.vala"
	_g_object_unref0 (action_bar);
#line 31 "../src/Views/DisplaysView.vala"
	_g_object_unref0 (button_grid);
#line 31 "../src/Views/DisplaysView.vala"
	_g_object_unref0 (detect_button);
#line 31 "../src/Views/DisplaysView.vala"
	_g_object_unref0 (dpi_grid);
#line 31 "../src/Views/DisplaysView.vala"
	_g_object_unref0 (dpi_label);
#line 31 "../src/Views/DisplaysView.vala"
	_g_object_unref0 (mirror_label);
#line 31 "../src/Views/DisplaysView.vala"
	block3_data_unref (_data3_);
#line 31 "../src/Views/DisplaysView.vala"
	_data3_ = NULL;
#line 31 "../src/Views/DisplaysView.vala"
	return obj;
#line 1400 "DisplaysView.c"
}

static void
display_displays_view_class_init (DisplayDisplaysViewClass * klass,
                                  gpointer klass_data)
{
#line 23 "../src/Views/DisplaysView.vala"
	display_displays_view_parent_class = g_type_class_peek_parent (klass);
#line 23 "../src/Views/DisplaysView.vala"
	g_type_class_adjust_private_offset (klass, &DisplayDisplaysView_private_offset);
#line 23 "../src/Views/DisplaysView.vala"
	G_OBJECT_CLASS (klass)->constructor = display_displays_view_constructor;
#line 23 "../src/Views/DisplaysView.vala"
	G_OBJECT_CLASS (klass)->finalize = display_displays_view_finalize;
#line 1415 "DisplaysView.c"
}

static void
display_displays_view_instance_init (DisplayDisplaysView * self,
                                     gpointer klass)
{
#line 23 "../src/Views/DisplaysView.vala"
	self->priv = display_displays_view_get_instance_private (self);
#line 1424 "DisplaysView.c"
}

static void
display_displays_view_finalize (GObject * obj)
{
	DisplayDisplaysView * self;
#line 23 "../src/Views/DisplaysView.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, DISPLAY_TYPE_DISPLAYS_VIEW, DisplayDisplaysView);
#line 24 "../src/Views/DisplaysView.vala"
	_g_object_unref0 (self->displays_overlay);
#line 26 "../src/Views/DisplaysView.vala"
	_g_object_unref0 (self->priv->dpi_combo);
#line 27 "../src/Views/DisplaysView.vala"
	_g_object_unref0 (self->priv->rotation_lock_grid);
#line 23 "../src/Views/DisplaysView.vala"
	G_OBJECT_CLASS (display_displays_view_parent_class)->finalize (obj);
#line 1441 "DisplaysView.c"
}

static GType
display_displays_view_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (DisplayDisplaysViewClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) display_displays_view_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DisplayDisplaysView), 0, (GInstanceInitFunc) display_displays_view_instance_init, NULL };
	GType display_displays_view_type_id;
	display_displays_view_type_id = g_type_register_static (gtk_grid_get_type (), "DisplayDisplaysView", &g_define_type_info, 0);
	DisplayDisplaysView_private_offset = g_type_add_instance_private (display_displays_view_type_id, sizeof (DisplayDisplaysViewPrivate));
	return display_displays_view_type_id;
}

GType
display_displays_view_get_type (void)
{
	static volatile gsize display_displays_view_type_id__once = 0;
	if (g_once_init_enter (&display_displays_view_type_id__once)) {
		GType display_displays_view_type_id;
		display_displays_view_type_id = display_displays_view_get_type_once ();
		g_once_init_leave (&display_displays_view_type_id__once, display_displays_view_type_id);
	}
	return display_displays_view_type_id__once;
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

